/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2006, 2012. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

package com.worklight.androidnativeapp;

import com.worklight.wlclient.api.WLClient;
import com.worklight.wlclient.api.WLProcedureInvocationData;
import com.worklight.wlclient.api.WLRequestOptions;

import android.os.Bundle;
import android.app.Activity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class AndroidNativeApp extends Activity {
	private Button buttonConnect = null;
	private Button buttonInvoke = null;
	private static TextView textView = null;
	private static AndroidNativeApp _this;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_android_native_app);
        _this = this;

        buttonConnect = (Button)findViewById(R.id.buttonConnect);
        buttonInvoke = (Button)findViewById(R.id.buttonInvoke);
        textView = (TextView)findViewById(R.id.textView);
        
		final WLClient client = WLClient.createInstance(this);
        
        buttonConnect.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				updateTextView("Connecting...");
				client.connect(new MyConnectListener());
			}
		});
        
        buttonInvoke.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				updateTextView("Invoking procedure...");
				
				String adapterName = "RSSReader";
				String procedureName = "getFeedsFiltered";
				
				WLProcedureInvocationData invocationData = 
						new WLProcedureInvocationData(adapterName, procedureName);
				
				Object[] parameters = new Object[] {"param1", "param2", 3, false};
				invocationData.setParameters(parameters);
				
				WLRequestOptions options = new WLRequestOptions();
				options.setTimeout(30000);
				
				WLClient client = WLClient.getInstance();
				client.invokeProcedure(invocationData, new MyInvokeListener(), options);
			}
		});
    }
    
    public static void updateTextView(final String str){
    	Runnable run = new Runnable() {			
			public void run() {
		    	textView.setText(str);				
			}
		};
		_this.runOnUiThread(run);
    }
}
